# Dotgrid

Dotgrid is a simple vector drawing application. 

<img src='https://raw.githubusercontent.com/hundredrabbits/Dotgrid/master/PREVIEW.jpg' width="600"/>

## Guide

Clicking on the canvas will insert control points, up to 3CPs. CPs can be moved with the arrows. Clicking one of the path icons, or pressing one of the shortcuts, will draw a stroke between them. The newly created segment's handles can be moved by clicking and dragging them.

Hold `shift` to drag entire layer, hold `alt` to delete a vertex.

## Controls

### File
- New: `CmdOrCtrl+N`
- Open: `CmdOrCtrl+O`
- Save: `CmdOrCtrl+S`

### Edit
- Copy: `CmdOrCtrl+C`
- Cut: `CmdOrCtrl+X`
- Paste: `CmdOrCtrl+V`
- Undo: `CmdOrCtrl+Z`
- Redo: `CmdOrCtrl+Shift+Z`
- Delete: `Backspace`
- Deselect: `Esc`

### Stroke
- Line: `A`
- Arc: `S`
- Arc Rev: `D`
- Bezier: `F`
- Connect: `Z`

### Effect
- Linecap: `Q`
- Linejoin: `W`
- Mirror: `E`
- Fill: `R`
- Dash: `T`
- Color: `G`
- Thicker: `}`
- Thinner: `{`
- Thicker +5: `]`
- Thinner -5: `[`

### Manual
- Add Point: `Enter`
- Move Up: `Up`
- Move Right: `Right`
- Move Down: `Down`
- Move Left: `Left`
- Remove Point: `CmdOrCtrl+Backspace`

### Layers
- Foreground: `CmdOrCtrl+1`
- Middleground: `CmdOrCtrl+2`
- Background: `CmdOrCtrl+3`

### View
- Tools: `U`
- Grid: `H`

### Mode
- Picker: `CmdOrCtrl+P`

<img src='https://cdn.rawgit.com/hundredrabbits/Dotgrid/master/LAYOUT.svg?v=4' width="600"/>

## Extras

- Download additional [themes](https://github.com/hundredrabbits/Themes).
- Support this project through [Patreon](https://patreon.com/100).
- See the [License](LICENSE.md) file for license rights and limitations (MIT).
